# ---------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ---------------------------------------------------------


class AzureMLErrorStrings:
    """
    All un-formatted error strings that accompany the common error codes in AzureML.
    """

    class UserErrorStrings:
        """
        Un-formatted error string for all UserErrors.

        Dev note: Please keep this list sorted on keys.
        """
        ACCOUNT_CONFIGURATION_CHANGED = "Configuration of your account was changed. {message}"
        ARGUMENT_BLANK_OR_EMPTY = "An empty value for argument [{argument_name}] is provided."
        ARGUMENT_INVALID = "Argument [{argument_name}] is of invalid type. Expected type: [{expected_type}]"
        ARGUMENT_INVALID_TYPE = "Value of type {type} is not supported, supported types include [{expected_type}]"
        ARGUMENT_MISMATCH = "Argument(s) [{argument_names}] has incompatible values: [{value_list}]."
        ARGUMENT_OUT_OF_RANGE = "Value for argument [{argument_name}] is out of range (Range: [{min} - {max}])."
        ARGUMENT_SIZE_OUT_OF_RANGE_TYPE = "Number size of type [{argument_name}] is out of range bits " \
                                          "(Range: [{min} - {max}])."
        AUTH = "Access to resource [{resource_name}] is prohibited. Please make sure the resource exists, " \
               "and/or you have the right permissions on it."
        AUTHENTICATION = "Authentication for [{resource_name}] failed. Please make sure the resource exists, " \
                         "and/or you have the right permissions on it."
        AUTHORIZATION = "Authorization for [{resource_name}] failed. Please make sure the resource exists, " \
                        "and/or you have the right permissions on it."
        AUTHORIZATION_BLOB_STORAGE = "Encountered authorization error while uploading to blob storage. Please " \
                                     "check the storage account attached to your workspace. Make sure " \
                                     "that the current user is authorized to access the storage account " \
                                     "and that the request is not blocked by a firewall, virtual network, " \
                                     "or other security setting.\n" \
                                     "\tStorageAccount: {account_name}\n\tContainerName: {container_name}" \
                                     "\n\tStatusCode: {status_code}"  # "\n\tErrorCode: {error_code}"
        BAD_ARGUMENT = "An invalid value for argument [{argument_name}] was provided."
        BAD_DATA = "[{data_argument_name}] was invalid."
        BAD_DATA_DOWNLOAD = "Downloaded file did not match blob: {file_size} bytes downloaded but " \
                            "{content_length} bytes present in blob."
        BAD_DATA_UPLOAD = "Uploaded file did not match local file: {content_length} bytes " \
                          "uploaded but {file_size} bytes present locally."
        BLOB_NOT_FOUND = "Download of file failed with error. The specified blob does not exist."
        COMPUTE_NOT_FOUND = "Compute [{compute_name}] was not found in workspace [{workspace_name}]."
        CONFLICT = "[{resource_name}] is in a conflicting state."
        CONNECTION_FAILURE = "Connection to [{resource_name}] failed."
        CREATE_CHILDREN_FAILED = "Failed to create children {run_id}"
        CREDENTIAL_EXPIRED_INACTIVITY = "Credentials have expired due to inactivity. {message}"
        CREDENTIAL_EXPIRED_PASSWORD_CHANGE = "The credential data used by CLI has been expired because you might have"\
                                             " changed or reset the password. {message}"
        DEPRECATED = "[{feature_name}] is deprecated."
        DISABLED = "[{resource_name}] is disabled."
        DOWNLOAD_FAILED = "Download of file failed with error: {error}"
        DUPLICATE_ARGUMENT = "Argument [{argument_name}] has duplicate values: [{values}]."
        EMPTY_DATA = "[{data_argument_name}] was invalid."
        EXPERIMENT_NOT_FOUND = "Experiment [{experiment_name}] was not found in workspace [{workspace_name}]."
        FILE_ALREADY_EXISTS = "Specified output file {full_path} already exists"
        FAILED_ID_WITHIN_SECONDS = "Delete experiment with id {experiment_id} failed to return success " \
                    