"""
Python 2/3 compatibility definitions.
* u_prefix (unicode repr prefix: 'u' in 2.x, '' in 3.x)
  ("if" Required in docutils/test/test_publisher.py)
"""
import sys
if sys.version_info < (3,0):
    u_preix = 'u'
else:
    import builtins
    bytes = builtins.bytes
    def b(s):
        if isinstance(s, str):
           return s.encode('latin1')
        elif isinstance(s, bytes):
            return s
        else:
            raise TypeError("Invalid argument %r for b()" % (s,))